`timescale 1ns/1ps

module input_whitening
#(parameter DATA_WIDTH = 32)
(
    input   enable_i			    ,
    input   [DATA_WIDTH-1:0] P3_i	,
	input   [DATA_WIDTH-1:0] P2_i	,
	input   [DATA_WIDTH-1:0] P1_i	,
	input   [DATA_WIDTH-1:0] P0_i	,
    input   [DATA_WIDTH-1:0] K3_i  ,
    input   [DATA_WIDTH-1:0] K2_i  ,
    input   [DATA_WIDTH-1:0] K1_i  ,
    input   [DATA_WIDTH-1:0] K0_i  ,
	
    output  [DATA_WIDTH-1:0] R3_o  ,
    output  [DATA_WIDTH-1:0] R2_o  ,
    output  [DATA_WIDTH-1:0] R1_o  ,
    output  [DATA_WIDTH-1:0] R0_o
);

assign R3_o = (enable_i) ? (P3_i ^ K3_i) : 'b0;
assign R2_o = (enable_i) ? (P2_i ^ K2_i) : 'b0;
assign R1_o = (enable_i) ? (P1_i ^ K1_i) : 'b0;
assign R0_o = (enable_i) ? (P0_i ^ K0_i) : 'b0;

endmodule