`timescale 1ns/1ps

module input_whitening
#(parameter DATA_WIDTH = 128)
(
    input   enable_i					 ,
    input   [DATA_WIDTH-1:0] plain_text_i,
    input   [(DATA_WIDTH/4)-1:0] K0_i    ,
    input   [(DATA_WIDTH/4)-1:0] K1_i    ,
    input   [(DATA_WIDTH/4)-1:0] K2_i    ,
    input   [(DATA_WIDTH/4)-1:0] K3_i    ,
	
    output  [(DATA_WIDTH/4)-1:0] R0_o    ,
    output  [(DATA_WIDTH/4)-1:0] R1_o    ,
    output  [(DATA_WIDTH/4)-1:0] R2_o    ,
    output  [(DATA_WIDTH/4)-1:0] R3_o
);

wire [DATA_WIDTH-1:0] key	   ;
wire [DATA_WIDTH-1:0] whitening;

assign key 	= {K0_i,K1_i,K2_i,K3_i};
assign whitening = plain_text_i ^ key;
assign {R0_o,R1_o,R2_o,R3_o} = (enable_i) ? whitening[DATA_WIDTH-1:0] : 'b0;

endmodule