`timescale 1ns/1ps

module output_whitening
#(parameter DATA_WIDTH = 128)
(
    input   clk_i,
    input   reset_ni,
    input   enable_i,
    input   [DATA_WIDTH-1:0] data_i,
    input   [(DATA_WIDTH/4)-1:0] K0_i,
    input   [(DATA_WIDTH/4)-1:0] K1_i,
    input   [(DATA_WIDTH/4)-1:0] K2_i,
    input   [(DATA_WIDTH/4)-1:0] K3_i,
    output  [(DATA_WIDTH/4)-1:0] R0_o,
    output  [(DATA_WIDTH/4)-1:0] R1_o,
    output  [(DATA_WIDTH/4)-1:0] R2_o,
    output  [(DATA_WIDTH/4)-1:0] R3_o
);

wire [DATA_WIDTH-1:0] key;
reg [DATA_WIDTH-1:0] whitening;

assign key = {K2_i,K3_i,K0_i,K1_i};

always @(posedge clk_i or negedge reset_ni) begin
    if(~reset_ni)
        whitening <= 'b0;
    else
        if(enable_i)
            whitening <= data_i ^ key;
end

assign {R2_o,R3_o,R0_o,R1_o} = whitening [DATA_WIDTH-1:0];
      
    
endmodule